package org.gjt.jsp;

import java.io.*;
 
public class Dirlist extends File
{
    public Dirlist( String dirname )
	{
		super( dirname );
	}
 
    public String[] list( final String mask )
	{
        return super.list( new FilenameFilter()
			{
				public boolean accept( File dir, String name )
				{
					return match( name, mask );
				}
			}
		);
    }
 
    public boolean match( String string, String pattern )
	{
        final int  sl = string.length();
        final int  pl = pattern.length();
        int        pos;
 
        // System.out.println( "match(\"" + string + "\", \"" + pattern + "\")" );
        for(	pos = 0;
				pos<sl && pos<pl && (pattern.charAt(pos)=='?' || pattern.charAt(pos)==string.charAt(pos));
				++pos)
            ;

        return	pos == pl ?
				pos == sl :
				pattern.charAt(pos) == '*' && (match(string.substring(pos), pattern.substring(pos+1)) || (pos < sl && match(string.substring(pos+1), pattern.substring(pos))));
    }
 
}

 


